/// <reference types="node" />
import { NodeFileTraceOptions, NodeFileTraceResult, NodeFileTraceReasons, Stats } from './types';
export declare function nodeFileTrace(files: string[], opts?: NodeFileTraceOptions): Promise<NodeFileTraceResult>;
export declare class Job {
    ts: boolean;
    base: string;
    cwd: string;
    conditions: string[];
    exportsOnly: boolean;
    paths: Record<string, string>;
    ignoreFn: (path: string, parent?: string) => boolean;
    log: boolean;
    mixedModules: boolean;
    analysis: {
        emitGlobs?: boolean;
        computeFileReferences?: boolean;
        evaluatePureExpressions?: boolean;
    };
    private fileCache;
    private statCache;
    private symlinkCache;
    private analysisCache;
    fileList: Set<string>;
    esmFileList: Set<string>;
    processed: Set<string>;
    warnings: Set<Error>;
    reasons: NodeFileTraceReasons;
    constructor({ base, processCwd, exports, conditions, exportsOnly, paths, ignore, log, mixedModules, ts, analysis, cache, }: NodeFileTraceOptions);
    readlink(path: string): string | null;
    isFile(path: string): boolean;
    isDir(path: string): boolean;
    stat(path: string): Stats | null;
    resolve(id: string, parent: string, job: Job, cjsResolve: boolean): string | string[];
    readFile(path: string): string | Buffer | null;
    realpath(path: string, parent?: string, seen?: Set<unknown>): string;
    emitFile(path: string, reason: string, parent?: string, isRealpath?: boolean): boolean | undefined;
    getPjsonBoundary(path: string): string | undefined;
    emitDependency(path: string, parent?: string): Promise<void>;
}
